unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin, ExtCtrls, Mask, UntPublic;

type
  TProcessType = (ptStart, ptEnd);

  TMainForm = class(TForm)
    label_addr: TLabel;
    label_com_type: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    label_no: TLabel;
    label_type: TLabel;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Button6: TButton;
    Button7: TButton;
    rzedt_IP: TEdit;
    CbxComType: TComboBox;
    CbxDevType: TComboBox;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    GroupBox5: TGroupBox;
    Button3: TButton;
    Label2: TLabel;
    Label3: TLabel;
    dtp_Start: TDateTimePicker;
    dtp_End: TDateTimePicker;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    Button8: TButton;
    Button9: TButton;
    GroupBox4: TGroupBox;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button21: TButton;
    Button22: TButton;
    cbbChoice_Dev: TComboBox;
    Label4: TLabel;
    edtPortNumber: TEdit;
    edtPwd: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    GroupBox6: TGroupBox;
    Button26: TButton;
    Button27: TButton;
    ComboBox2: TComboBox;
    Edit3: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    btn1: TButton;
    lbl1: TLabel;
    edtServIpAddress: TEdit;
    cbbDviceID: TComboBox;
    ProgressBar1: TProgressBar;
    SetNameTable: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);

    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button26Click(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure SetNameTableClick(Sender: TObject);
  private
    { Private declarations }
    FDevInfo: PDevInfo;
    FExePath: string;
    procedure InitInfo;
    procedure InitDeviceInfo(DevID: string;
                             DevType: string; CommType: string; IPAddr: string;PortNumber: string; Password: string);
    procedure InitDevice();
    procedure WriteOperationLog(OperatorStr, ResultStr: string;
                                NeedParse: Boolean = False;
                                ParseCommand: string = '');
    function ParseResultInfo(ResultStr, CommandStr: string): string;
    procedure ExecProcess(ProcessType: TProcessType; ID: string = '');
    procedure GetPic(ANameList, APath: string);
    procedure SavePic(AFile, APic: string);
  public
    { Public declarations }

  end;

var
  MainForm: TMainForm;
  function WriteFile(pDevInfo:PChar;devInfoLen:Cardinal;pRecvBuf:PChar;pRecvLen:Cardinal): Integer; stdcall;

implementation

uses
  UntHW_SelectDateTime,
  UntHW_EmployeeID, DateUtils, StrUtils, UnitHW_SetWorkStatusCode,
  UntSetEmployeeInfo, UntSetNetInfo, UntUpgradeFirmware,
  UntSetAttendInterval;

{$R *.dfm}

function WriteFile(pDevInfo:PChar;devInfoLen:Cardinal;pRecvBuf:PChar;pRecvLen:Cardinal): Integer; stdcall;
var
temPchar,Pchar1,Pchar2:PChar;
filepath: string;
slFile: TStringList;
f : System.TextFile; // ıļ
dt:TDateTime;
dtime:TDateTime;
AYear, AMonth, ADay, AHour, AMinute,ASecond, AMilliSecond: Word;
begin
    Pchar1:= pDevInfo;
    Pchar2:= pRecvBuf;

    filePath := ExtractFilePath(Application.ExeName) + 'Output Files';
    if DirectoryExists(filePath)=False then
    CreateDirectory(PChar(filePath),Nil);
    dt:=now;
    DecodeDateTime(dt,AYear, AMonth, ADay, AHour, AMinute,ASecond, AMilliSecond);

    slFile := TStringList.Create;
    slFile.Clear;
    slFile.Add(Pchar2);
    slFile.SaveToFile(filePath + '\' +Pchar1+ '-'+inttostr(AYear)+'-'+inttostr(AMonth)+'-'+inttostr(ADay)+'-'+inttostr(AHour)+'-'+inttostr(AMinute)+'-'+inttostr(ASecond)+'.txt');  //+ '-'+AMinute+ '-'+ASecond
    slFile.Free;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  InitInfo;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close;
end;
procedure TMainForm.InitDevice();
begin
//cbbDviceID.Items.Strings[0]
  InitDeviceInfo(cbbDviceID.Text, CbxDevType.Text,
                 CbxComType.Text, Trim(rzedt_IP.Text),edtPortNumber.Text,edtPwd.Text);
end;
procedure TMainForm.InitDeviceInfo(DevID: string;DevType: string; CommType: string; IPAddr: string;PortNumber: string; Password: string);
begin
  if not Assigned(FDevInfo) then
    New(FDevInfo);
  FDevInfo.DevID     := DevID;
  FDevInfo.DevType   := DevType;
  FDevInfo.CommType  := CommType;
  FDevInfo.IPAddress := IPAddr;
  FDevInfo.PortNumber  := PortNumber;
  FDevInfo.Password  := Password;
 // DeviceInfo( dev_id = \"%s\" dev_type = \"%s\" comm_type = \"%s\" ip_address = \"%s\" password = \"%s\" port_number = \"%d\")",
end;

procedure TMainForm.InitInfo;
var
sRlt: string;
sRltew: Integer;
begin
  //Initialize communication type
  CbxComType.Clear;
  CbxComType.Items.Add('ip');
  CbxComType.ItemIndex := 0;
    //Initialize device type
  CbxDevType.Clear;
  CbxDevType.Items.Add('HW_HDCP');
  CbxDevType.ItemIndex := 0;

  //sRltew:=StrToInt(cbbDviceID.Items.Text); 
 // DeviceInfo( dev_id = \"%s\" dev_type = \"%s\" comm_type = \"%s\" ip_address = \"%s\" password = \"%s\" port_number = \"%d\")",
    InitDevice();
  //FDLLPath := ExtractFilePath(Application.ExeName) + 'Dev\';
  FDLLPath := ExtractFilePath(Application.ExeName);
  FExePath := ExtractFilePath(Application.ExeName);
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
end;

procedure TMainForm.WriteOperationLog(OperatorStr, ResultStr: string;
  NeedParse: Boolean; ParseCommand: string);
var
  sFile, sRlt: string;
  sl: TStringList;
begin
  sl := TStringList.Create;
  try
    sFile := FExePath + OperatorStr + OperationLogTxt;
    if FileExists(sFile) then
      sl.LoadFromFile(sFile);
    if NeedParse then
      sl.Clear;
    if sl.Count > 0 then
      sl.Add('---------------------------------------------------------------');
    sl.Add('Operation Name' + OperatorStr);
    sl.Add('Operation Time' + DateTimeToStr(Now));
    if NeedParse then  
    begin
      sRlt := ParseResultInfo(ResultStr, ParseCommand);
      sl.Add('Operation Log' + sRlt);
    end else
      sl.Add('Operation Log' + ResultStr);
    sl.SaveToFile(sFile);
  finally
    sl.Free;
  end;
end;

function TMainForm.ParseResultInfo(ResultStr, CommandStr: string): string;
var
  iStartPos: Integer;
  tmpStr, sID, sRlt: string;
  pCommand, pResult: PChar;
  iResult: Cardinal;
  sl: TStringList;
begin
  Result := ResultStr;
  iStartPos := Pos(HwDev_Total, ResultStr);
  if iStartPos = 0 then Exit;
  sl := TStringList.Create;
  try
    tmpStr := Copy(Result, iStartPos, Length(Result));
    iStartPos := Pos(HwDev_Seporator, tmpStr);
    if iStartPos = 0 then Exit;
    tmpStr := Copy(tmpStr, iStartPos + 1, Length(tmpStr));
    iStartPos := Pos(HwDev_Seporator, tmpStr);
    if iStartPos = 0 then Exit;
    Result := Copy(tmpStr, 0, iStartPos - 1);
    sl.Add(#13#10 + '  total[' + Result + ']');
    Result := Copy(tmpStr, iStartPos + 1, Length(tmpStr));
    iStartPos := Pos(HwDev_Seporator, Result);
    while iStartPos > 0 do
    begin
      Result := Copy(Result, iStartPos + 1, Length(Result));
      iStartPos := Pos(HwDev_Seporator, Result);
      sID := Copy(Result, 0, iStartPos - 1);
      pCommand := PChar(CommandStr + '(id="' + sID + '")');  //Get employee information by ID
      ExecProcess(ptStart, sID);  //add the progress bar
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                               pCommand, Length(pCommand),
                               @pResult, @iResult, nil);
      if CommandStr = HwDev_DelEmployee then
        sl.Add('  delete employee[' + sID + ']delete result[' + sRlt + ']')
      else
        sl.Add('  employee info[' + sRlt + ']');
      Result := Copy(Result, iStartPos + 1, Length(Result));
      iStartPos := Pos(HwDev_Seporator, Result);
    end;
    Result := sl.Text;
  finally
    sl.Free;
  end;
end;

procedure TMainForm.ExecProcess(ProcessType: TProcessType; ID: string);
begin
  if ProcessType = ptStart then
  begin
    Label1.Caption := '  processing [' + ID + ']please wait';
    ProgressBar1.Position := ProgressBar1.Position + 1;
    if ProgressBar1.Position >= 99 then
      ProgressBar1.Position := 99;
  end else
  begin
    Label1.Caption := '  finish';
    ProgressBar1.Position := 100;
    Sleep(1000);
    Label1.Caption := '';
    ProgressBar1.Position := 0;
  end;
  Application.ProcessMessages;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Button6Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
begin
  sCaption := Button6.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('InitDevice()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
    ShowMess( 'success')
  else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
begin
  sCaption := Button7.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('InitDeviceAdmin()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
    ShowMess( 'success')
  else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button8Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sSet, sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  sCaption := 'Set Work status';
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  frmHW_SetWorkStatusCode := TfrmHW_SetWorkStatusCode.Create(Application);
  try
    if frmHW_SetWorkStatusCode.ShowModal = mrOk then
    begin
      sSet := frmHW_SetWorkStatusCode.sRst;
      pCommand := PChar('SetWorkStatus(' + sSet + ')');
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        if IsCmdExecSuccess(sRlt) then
          ShowMess( 'success')
        else
          ShowMess( 'failure');
      end;
  finally
    frmHW_SetWorkStatusCode.Free;
  end;
end;
procedure TMainForm.Button13Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
begin
  sCaption := Button13.Caption;
   InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('GetEmployeeID()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
  begin
    WriteOperationLog(sCaption, sRlt, True, HwDev_GetEmployee);
    ExecProcess(ptEnd);
    ShowMess( 'successdetails are in[' + FExePath + sCaption + OperationLogTxt + ']');
  end else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button9Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sDevTime, sCaption: string;
begin
  sCaption := Button9.Caption;
   InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('ClearWorkStatus()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
  begin
    ShowMess( 'success');
  end else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button14Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  sCaption := Button14.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  frmHW_EmployeeID := TfrmHW_EmployeeID.Create(Application);
  try
    if frmHW_EmployeeID.ShowModal = mrOk then
    begin            
      SID := frmHW_EmployeeID.StartID;
      EID := frmHW_EmployeeID.EndID;
      for i := SID to EID do
      begin
        ExecProcess(ptStart, IntToStr(i));  //add the progress bar
        pCommand := PChar('GetEmployee(id="' + IntToStr(i) + '")');
        sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        //if IsCmdExecSuccess(sRlt) then  
          WriteOperationLog(sCaption, sRlt);
      end;
      ExecProcess(ptEnd);
      ShowMess( 'details in [' + FExePath + sCaption +   OperationLogTxt + ']');
    end;
  finally
    frmHW_EmployeeID.Free;
  end;
end;

procedure TMainForm.Button15Click(Sender: TObject);
const
  FaceData = 'AAF6/dH/bgDpA+37bgB1++0HqQO/+gECMP/F/TD7mAHBAj4DPAdo+goDvACoA5z/RAVf9zAJ' +
             'RvzW+yIE9/+NBUkD0Pz/+0z/M//7AOUBBv3BB8wERP+hBacBWfxU/JD6GvHM/mz/fgFl/G3/' +
             'WQaV84sDDwJKAET/Y/vt/OUBWvq9+Kz+5gBS/h0I4P1UA0H//f+UAU/7E/NcBWL+3/8m/i0O' +
             'wf30AQ4HqwBnBUf+CPyx+Z/+/v7v+M/9PAJ690H/KAavAdj+vP/qAOn4hgKVAEoGmAb3ATb+' +
             'EvuUAHwCz/ti/HIA6gC08k4ARvyLAcz/fgJG9JcFrgPF/XT7Sf6x+/H4xvqPAoH/xvnQ/O79' +
             '+QRFBFz8KgHUAWYBwvtwA70AsgHoAfMDKf7R+lkAqvzOBXcDywfJ+x//WvcS/pYDcAPk+zj3' +
             'nwFgAx0BtAI6AFf8i/t//toEMf39ANr5uPRVAQ3/TfyZBZn/BAcu/HsD0gekARYAWAGV9FD9' +
             'bf4gAVUBuP8v/Ub9IgAPBFn6ZvxjAoscof/2CE7Pav/7EKoBcwrxFKYFUvmJFJYFOPBrBDoi' +
             '8tpm8+wPte+GD5kIGviODNr1Yf7H/zr5uhp8CMQmbv8a4rDwOvFc5SQSPf11BsIHf/unEFQD' +
             '8BT6+5QIRPehDSEizwGW754GRARK7wHxyv4v6hsLvwL79WcER+8WAxL+DxGK8XH/sAjI/UkX' +
             'jRlP7tEhh9GBCAXv8hht7MDy5SDj9mP1dwCi6h3yjwBACUb3ZgE3/zgDYwJ8DY0V8gISAkkO' +
             'H/Zt8bEJpgGyHrf7a/Y3AIz9Y+/H8Eb7dgrU+08HkAt7BvwPAx1v+6gEkfJYAHf9IQDQBYMJ' +
             'rA6vDhv/IAM=';
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption, sSetInfo, str: string;
  sSetInfo111,sSetInfo22: string;
  nstrcmd:integer;
begin
  sCaption := Button15.Caption;
  sSetInfo111:=cbbChoice_Dev.Items[cbbChoice_Dev.ItemIndex];
  sSetInfo22:=cbbDviceID.Text;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  //DevInfoStr = 'DeviceInfo(dev_id = "%s" dev_type = "%s" comm_type = "%s" ip_address = "%s" port_number = "%s" password = "%s")';
  SetEmployeeInfo := TSetEmployeeInfo.Create(Application);
  SetEmployeeInfo.m_strDevType:=cbbChoice_Dev.Items[cbbChoice_Dev.ItemIndex];
  try
    if SetEmployeeInfo.ShowModal = mrOk then
    begin
     // str := StringReplace(sSetEmployeeInfo, ''#$D#$A'', '', [rfReplaceAll]);
      pCommand := PChar(sSetEmployeeInfo);
      nstrcmd:=Length(pCommand);
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
    if IsCmdExecSuccess(sRlt) then
      ShowMess( 'success')
     else
      ShowMess( 'failure');
     end;
  finally
    SetEmployeeInfo.Free;
  end;
end;


procedure TMainForm.Button16Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  sCaption := Button16.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  frmHW_EmployeeID := TfrmHW_EmployeeID.Create(Application);
  try
    if frmHW_EmployeeID.ShowModal = mrOk then
    begin
      SID := frmHW_EmployeeID.StartID;
      EID := frmHW_EmployeeID.EndID;
      for i := SID to EID do
      begin
        pCommand := PChar('DeleteEmployee(id="' + IntToStr(i) + '")');
        sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        //if IsCmdExecSuccess(sRlt) then  //
          WriteOperationLog(sCaption, sRlt);
      end;
      ShowMess( 'details in[' + FExePath +  OperationLogTxt + ']');
    end;
  finally
    frmHW_EmployeeID.Free;
  end;
end;



procedure TMainForm.Button17Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
begin
  sCaption := Button17.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('DeleteAllEmployee()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
  begin
    WriteOperationLog(sCaption, sRlt, True, HwDev_DelEmployee);  //progress bagin
    ExecProcess(ptEnd);  //progress end
    ShowMess( 'successdetails in[' + FExePath + sCaption + OperationLogTxt + ']');
  end else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption, sType, sPath: string;
  sPicPath: array[PIC_OK..PIC_CARD] of string;
  dtStart, dtEnd: TDate;
  picType: TPicType;
begin
  sCaption := Button10.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);

  dtStart := dtp_Start.Date;
  dtEnd   := dtp_End.Date;
  while dtStart <= dtEnd do
  begin
    //create date directory
    CreateDirectory(PChar(FExePath + DateToStr(dtStart)), nil);

    //create Ok directory
    sPicPath[PIC_OK] := FExePath + DateToStr(dtStart) + '\PIC_OK\';
    CreateDirectory(PChar(sPicPath[PIC_OK]), nil);
    //create FAIL directory
    sPicPath[PIC_FAIL] := FExePath + DateToStr(dtStart) + '\PIC_FAIL\';
    CreateDirectory(PChar(sPicPath[PIC_FAIL]), nil);
    //create CARD directory
    sPicPath[PIC_CARD] := FExePath + DateToStr(dtStart) + '\PIC_CARD\';
    CreateDirectory(PChar(sPicPath[PIC_CARD]), nil);

    for picType := PIC_OK to PIC_CARD do
    begin
      //get file list
      if picType = PIC_OK then
        sType := 'face';
      if picType = PIC_FAIL then
        sType := 'photo';
      if picType = PIC_CARD then
        sType := 'card';
      pCommand := PChar(Format('GetPictureName(time="%s" type="%s" )', [DateToStr(dtStart), sType]));
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                               pCommand, Length(pCommand),
                               @pResult, @iResult, nil);
      if IsCmdExecSuccess(sRlt) then
        GetPic(sRlt, sPicPath[picType]);
    end;
    dtStart := IncDay(dtStart);
  end;
end;

procedure TMainForm.GetPic(ANameList, APath: string);
const
  ctrl_name	= 'name="';
var
  iPos, i: Integer;
  sList, sName, sRlt: string;
  sl: TStringList;
  pCommand, pResult: PChar;
  iResult: Cardinal;
begin
  sl := TStringList.Create;
  try
    sList := ANameList;
    iPos := Pos(ctrl_name, sList);
    if iPos > 0 then
    begin
      sList := RightStr(sList, Length(sList) - iPos + 1);
      sList := StringReplace(sList, ctrl_name, ',', [rfReplaceAll]);
      sList := StringReplace(sList, '"', '', [rfReplaceAll]);
      sList := Trim(StringReplace(sList, ')', '', [rfReplaceAll]));
      sList := RightStr(sList, Length(sList) - 1);
      sl.CommaText := sList;
    end;

    for i := 0 to sl.Count - 1 do
    begin
      sName := sl.Strings[i];
      ExecProcess(ptStart, sName);
      //save pictures
      pCommand := PChar(Format('GetPicture(name="%s")', [sName]));
      pResult := nil;
      iResult := 0;
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                               pCommand, Length(pCommand),
                               @pResult, @iResult, nil);
      if IsCmdExecSuccess(sRlt) then
        SavePic(APath + ExtractFileName(sName), sRlt);
    end;
    ExecProcess(ptEnd);
  finally
    sl.Free;
  end;
end;

procedure TMainForm.SavePic(AFile, APic: string);
const
  ctrl_name = 'photo="';
var
  iPos: Integer;
  ImgLen: Cardinal;
  sPic: string;
begin
  //photoݣ628С<滻/
  //if is photo data, and  is 628, then convert '<'  to '/'
  iPos := Pos(ctrl_name, APic);
  if iPos > 0 then
  begin
    sPic := RightStr(APic, Length(APic) - iPos - Length(ctrl_name) + 1);
    sPic := Trim(StringReplace(sPic, ')', '', [rfReplaceAll]));
    ImgLen := Length(sPic);
    sPic := StringReplace(sPic, '<', '/', [rfReplaceAll]);
    CallHwDecodeDLL(FExePath, AFile, PChar(sPic), ImgLen);
  end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt: string;
begin
   InitDevice();

  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
 // FDevInfoStr :=PChar('DeviceInfo(dev_id = "1" dev_type = "HW_HDCP" comm_type = "ip" ip_address = "173.16.6.117" port_number = "9922"  password = "")');

  pCommand := PChar('GetDeviceInfo()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
    ShowMess('Device  does exist')
  else
    ShowMess('Device does not exist');
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sDevTime, sCaption: string;
begin
  sCaption := Button4.Caption;
   InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID,FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('GetDeviceInfo()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
  begin
    sDevTime := GetHWDeviceTime(sRlt);
    ShowMess( 'successDevie Time [' + sDevTime + ']');
  end else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;
procedure TMainForm.Button18Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
begin
  sCaption := Button18.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('GetRecord(start_time="1900-01-01 00:00:00" end_time="2099-12-31 24:00:00")');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
  begin
    WriteOperationLog(sCaption, sRlt);
    ShowMess( 'successdetails in[' + FExePath + sCaption + OperationLogTxt + ']');
  end else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button19Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption, sCommand: string;
begin
  sCaption := Button19.Caption;
   InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  frmHW_SelectDateTime := TfrmHW_SelectDateTime.Create(Application);
  try
    if frmHW_SelectDateTime.ShowModal = mrOk then
    begin  //date and time
      sCommand := Format('GetRecord(start_time="%s %s" end_time="%s %s")',
                        [DateToStr(frmHW_SelectDateTime.StartDate),
                         TimeToStr(frmHW_SelectDateTime.StartDateTime),
                         DateToStr(frmHW_SelectDateTime.EndDate),
                         TimeToStr(frmHW_SelectDateTime.EndDateTime)]);
      pCommand := PChar(sCommand);
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                               pCommand, Length(pCommand),
                               @pResult, @iResult, nil);
      if IsCmdExecSuccess(sRlt) then
      begin
        WriteOperationLog(sCaption, sRlt);
        ShowMess( 'finishdetails in[' + FExePath + sCaption + OperationLogTxt + ']');
      end else
        ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
    end;
  finally
    frmHW_SelectDateTime.Free;
  end;
end;
procedure TMainForm.Button20Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
begin
  sCaption := Button20.Caption;
   InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID,FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('DeleteAllRecord()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
    ShowMess( 'success')
  else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button5Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  sCaption := Button5.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('GetWorkStatus()');
        sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);

        if IsCmdExecSuccess(sRlt) then
          ShowMess( 'success! ' + sRlt)
        else
          ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button10Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  sCaption := 'Get work code';
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('GetWorkCode()');
        sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);

        if IsCmdExecSuccess(sRlt) then
          ShowMess( 'success! ' + sRlt)
        else
          ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button12Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt, sDevTime, sCaption: string;
begin
  sCaption := Button9.Caption;
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID,  FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('ClearWorkCode()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
  begin
    ShowMess( 'success!');
  end else
    ShowMess( 'failure' + #13#10 + 'reason[' + HwDev_ErrorInfo + ']');
end;

procedure TMainForm.Button11Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sSet, sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  sCaption := 'Set Work code';
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID,  FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  frmHW_SetWorkStatusCode := TfrmHW_SetWorkStatusCode.Create(Application);
  try
    if frmHW_SetWorkStatusCode.ShowModal = mrOk then
    begin
      sSet := frmHW_SetWorkStatusCode.sRst;

      pCommand := PChar('SetWorkCode(' + sSet + ')');
        sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        if IsCmdExecSuccess(sRlt) then
          ShowMess( ' success')
        else
          ShowMess( ' failure');
      end;  

  finally
    frmHW_SetWorkStatusCode.Free;
  end;
end;
procedure TMainForm.Button21Click(Sender: TObject);
var
  iResult: Cardinal;
  sCaption: string;
  pCommand, pResult: PChar;
  sRlt: string;
begin
  sCaption := 'Get Daylight';
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('GetDayLight()');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
     ShowMess( ' success! ' + sRlt )
  else
     ShowMess( 'failure!');
end;
procedure TMainForm.Button22Click(Sender: TObject);
var
  iResult: Cardinal;
  sCaption: string;
  pCommand, pResult: PChar;
  sRlt: string;
begin
  sCaption := 'Set Daylight';
  InitDevice();
  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID,FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
  pCommand := PChar('SetDayLight(support="1" start_time="5-10 0" end_time="11-10 0")');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
     ShowMess( 'success')
  else
     ShowMess( 'failue');
end;

procedure TMainForm.Button26Click(Sender: TObject);
var
  iResult,nServerInfoLen: Cardinal;
  strServerInfo: PChar;
  strIP, sCaption: string;
  tempint: Integer;
  nResult:integer;
begin
    tempint:=1;
      {
  InitDeviceInfo(cbbChoice_Dev.Value, '', CbxDevType.Text, Trim(rzedt_IP.Text),
                 CbxComType.ItemIndex);

  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.IPAddress]);
    m_serverIPCtrl.GetWindowText(strIP);

    if (strIP.Compare("0.0.0.0") == 0)
     begin
        AfxMessageBox("Wrong IP Address.");
        return;
    end;
    }
   // m_serverInfoStr = GetServerInfo(m_serverCommTypeStr,strIP,m_serverPort,"");//""滻ԭm_strPasswordԱһնڻϴ
   // char* strServerInfo = m_serverInfoStr.GetBuffer(m_serverInfoStr.GetLength());
    strServerInfo:=PChar('ServerInfo( comm_type = "'+ComboBox2.Items.Strings[0]+'"ip_address = "'+trim(edtServIpAddress.Text)+'" ip_port = "'+trim(Edit3.Text)+'"  password = "")');
    // strServerInfo:=PChar('ServerInfo( comm_type = "ip" ip_address = "173.16.6.186" ip_port = "9923"  password = "")');
    nServerInfoLen := Length(strServerInfo);
    try
      nResult := CallServerCommDLL(FDLLPath,1, strServerInfo, nServerInfoLen,@WriteFile);  //@WriteFile
    except
      on E:Exception do
      begin
        ShowMess(e.Message);
      end;
    end;
      if nResult=0 then
      begin
      ShowMess('successly') ;
      end
      else
      ShowMess('error');
end;

procedure TMainForm.btn1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Button27Click(Sender: TObject);
var
  iResult,nServerInfoLen: Cardinal;
  strServerInfo: PChar;
  strIP, sCaption: string;
  tempint: Integer;
  nResult:integer;
begin
    strServerInfo:=PChar('ServerInfo( comm_type = "'+ComboBox2.Items.Strings[0]+'"ip_address = "'+trim(edtServIpAddress.Text)+'" ip_port = "'+trim(Edit3.Text)+'"  password = "")');
    nServerInfoLen := Length(strServerInfo);
    try
      nResult := CallServerCommDLL(FDLLPath,0, strServerInfo, nServerInfoLen,@WriteFile);  //@WriteFile
    except
      on E:Exception do
      begin
        ShowMess(e.Message);
      end;
    end;
      if nResult=0 then
      begin
      ShowMess('successly') ;
      end
      else
      ShowMess('error');
end;

procedure TMainForm.Button23Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sSet, sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
 UpgradeFirmware := TUpgradeFirmware.Create(Application);
 try
    if UpgradeFirmware.ShowModal = mrOk then
    begin
      sSet := UpgradeFirmware.sRst;
      pCommand := PChar('UpdateFirmware(file="' + m_txtFileName + '" SN=\"'+strSN+'")');
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        if IsCmdExecSuccess(sRlt) then
          ShowMess( 'success')
        else
          ShowMess( 'failure');
      end;
  finally
    UpgradeFirmware.Free;
  end;

end;

procedure TMainForm.Button25Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sSet, sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
  SetNetInfo := TSetNetInfo.Create(Application);
 try
    if SetNetInfo.ShowModal = mrOk then
    begin
      sSet := SetNetInfo.sRst;
      pCommand := PChar('SetNetInfo(ip="' + strIP + '" netmask="' + strNM + '" gateway="' + strGW + '" commukey="' + strPassword + '")');
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        if IsCmdExecSuccess(sRlt) then
          ShowMess( 'success')
        else
          ShowMess( 'failure');
      end;
  finally
    SetNetInfo.Free;
  end;

end;

procedure TMainForm.Button24Click(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sSet, sRlt, sCaption: string;
  i, SID, EID: Integer;
begin
 SetAttendInterval := TSetAttendInterval.Create(Application);
 try
    if SetAttendInterval.ShowModal = mrOk then
    begin
      sSet := SetAttendInterval.sRst;
      pCommand := PChar('SetAttendanceInterval(interval="' + strAttendInterval + '")');
      sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                                 pCommand, Length(pCommand),
                                 @pResult, @iResult, nil);
        if IsCmdExecSuccess(sRlt) then
          ShowMess( 'success')
        else
          ShowMess( 'failure');
      end;
  finally
    SetAttendInterval.Free;
  end;
end;

procedure TMainForm.SetNameTableClick(Sender: TObject);
var
  iResult: Cardinal;
  pCommand, pResult: PChar;
  sRlt,m_strParameter: string;
begin
  InitDevice();

  FDevInfoStr := Format(DevInfoStr, [FDevInfo.DevID, FDevInfo.DevType, FDevInfo.CommType, FDevInfo.IPAddress, FDevInfo.PortNumber, FDevInfo.Password]);
 // FDevInfoStr :=PChar('DeviceInfo(dev_id = "1" dev_type = "HW_HDCP" comm_type = "ip" ip_address = "173.16.6.117" port_number = "9922"  password = "")');
  m_strParameter:='1="hanvon" 2="bill" 3="athena"'; //б
  pCommand := PChar('SetNameTable(' + m_strParameter + ')');
  sRlt := CallHwDevCommDLL(FDLLPath, PChar(FDevInfoStr), Length(FDevInfoStr),
                           pCommand, Length(pCommand),
                           @pResult, @iResult, nil);
  if IsCmdExecSuccess(sRlt) then
    ShowMess('Set name table successfully.')
  else
    ShowMess('Fail to set name table. The reason is');

end;

end.
