unit UntSetEmployeeInfo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, ComCtrls;

type
  TSetEmployeeInfo = class(TForm)
    Label1: TLabel;
    idEdit: TEdit;
    Label2: TLabel;
    nameEdt: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    calidtxt: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button1: TButton;
    Button2: TButton;
    cardnumEdt: TEdit;
    athoritycbb: TComboBox;
    entercbb: TComboBox;
    opendorcbb: TComboBox;
    checkcbb: TComboBox;
    facedateEdt: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure entercbbChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   sRst: string;
   m_strDevType: string;
   m_strEnterType: string;
   function GetInt16ByAuthorityName(strAuthorityName:string): string;
   function GetInt16ByEnterTypeName(strEnterTypeName:string): string;
  end;

var
  sSetEmployeeInfo:string;
  SetEmployeeInfo:TSetEmployeeInfo;
implementation

{$R *.dfm}

procedure TSetEmployeeInfo.Button1Click(Sender: TObject);
var
  sRlt, sCaption, sSetInfo,strAuthority,strEnterType: string;
    I:Integer;
    strfacedata: string;
begin
  strfacedata:='';

  strAuthority:= GetInt16ByAuthorityName(athoritycbb.Items.Strings[0]);
  if CompareStr(m_strDevType,'F810')=0 then
  begin
    strEnterType := GetInt16ByEnterTypeName(m_strEnterType);
    if ((CompareStr(m_strEnterType,'card')=0)or(CompareStr(m_strEnterType,'card&photo')=0))
       then
          sSetEmployeeInfo := Format('SetEmployee(id="%s" name="%s" calid="%s" ' +
                     'card_num="%s" authority="%s" enter_type="%s" opendoor_type="%s" check_type="%s")',
                     [idEdit.Text ,nameEdt.Text ,calidtxt.Text ,cardnumEdt.Text ,strAuthority,strEnterType,entercbb.Items.Strings[0],checkcbb.Items.Strings[0]])
         else
          sSetEmployeeInfo := Format('SetEmployee(id="%s" name="%s" calid="%s" ' +
                     'card_num="%s" authority="%s" enter_type="%s" opendoor_type="%s" check_type="%s" %s)',
                     [idEdit.Text ,nameEdt.Text ,calidtxt.Text ,cardnumEdt.Text ,strAuthority,strEnterType,opendorcbb.Items.Strings[0],checkcbb.Items.Strings[0],strfacedata]);
  end
    else
    begin
     if CompareStr(m_strDevType,'FK705')=0
      then
          sSetEmployeeInfo := Format('SetEmployee(id="%s" name="%s" calid="%s" ' +
                     'card_num="%s" authority="%s" check_type="%s" %s)',
                     [idEdit.Text ,nameEdt.Text ,calidtxt.Text ,cardnumEdt.Text,strAuthority,checkcbb.Items.Strings[0],strfacedata])
			else
          sSetEmployeeInfo := Format('SetEmployee(id="%s" name="%s" calid="%s" ' +
                     'card_num="%s" authority="%s" opendoor_type="%s" check_type="%s" %s)',
                     [idEdit.Text ,nameEdt.Text ,calidtxt.Text ,cardnumEdt.Text ,strAuthority,opendorcbb.Items.Strings[0],checkcbb.Items.Strings[0],strfacedata]);
   end;
  ModalResult := mrOk;
end;

procedure TSetEmployeeInfo.Button2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TSetEmployeeInfo.FormCreate(Sender: TObject);

begin
  sRst := '';
 // m_strDevType:=m_devType;
  if CompareStr(m_strDevType,'F810')=0 then
  begin
      Label5.Enabled:=false;
      opendorcbb.Enabled:=false;
      Label9.Enabled:=false;
      checkcbb.Enabled:= false;
  end;

  if CompareStr(m_strDevType,'FK705')=0 then
  begin
     Label5.Enabled:=false;
     opendorcbb.Enabled:=false;
     athoritycbb.Clear;
     athoritycbb.AddItem('Attend Only',Sender);
     athoritycbb.AddItem('Others',Sender);
     athoritycbb.ItemIndex:=0;
  end;
end;

function TSetEmployeeInfo.GetInt16ByAuthorityName(strAuthorityName:string): string;
var
 strAuthorityInt16:string;
begin
    strAuthorityInt16:='0X0';
    if CompareStr(strAuthorityName,'Attend&Access')=0 then  strAuthorityInt16:='0X0';
    if CompareStr(strAuthorityName,'Attend Only')=0 then  strAuthorityInt16 := '0X55';
    if CompareStr(strAuthorityName,'Access Only')=0 then  strAuthorityInt16 := '0XAA';
    if CompareStr(strAuthorityName,'Others')=0 then  strAuthorityInt16 :='0XFF';
    result:=strAuthorityInt16;
end;

function TSetEmployeeInfo.GetInt16ByEnterTypeName(strEnterTypeName:string): string;
var
 strEnterType:string;
begin
    strEnterType:='0X00';
    if CompareStr(strEnterTypeName,'face')=0 then  strEnterType:='0X01';
    if CompareStr(strEnterTypeName,'card&photo')=0 then  strEnterType := '0X02';
    if CompareStr(strEnterTypeName,'card&face')=0 then  strEnterType := '0X04';
    if CompareStr(strEnterTypeName,'card')=0 then  strEnterType :='0X08';
    result:=strEnterType;
end;
procedure TSetEmployeeInfo.entercbbChange(Sender: TObject);
begin
m_strEnterType:=entercbb.Items.Strings[0];
end;

end.
