unit UntHW_EmployeeID;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Mask;

type
  TfrmHW_EmployeeID = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    rzedt_EndID: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    rzcbx_Single: TCheckBox;
    Panel3: TPanel;
    Label1: TLabel;
    rzedt_EmployeeID: TEdit;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure rzedt_EmployeeIDKeyPress(Sender: TObject; var Key: Char);
    procedure rzedt_EndIDKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure rzcbx_SingleClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    StartID,
    EndID: Integer;
  end;

var
  frmHW_EmployeeID: TfrmHW_EmployeeID;

implementation

uses
  UntPublic;

{$R *.dfm}

procedure TfrmHW_EmployeeID.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close;
end;

procedure TfrmHW_EmployeeID.rzedt_EmployeeIDKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not(Key in ['0'..'9', #8]) then
  begin
    ShowMess('please input a number!');
    Key := #0;
  end;
end;

procedure TfrmHW_EmployeeID.rzedt_EndIDKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not(Key in ['0'..'9', #8]) then
  begin
    ShowMess('please input a number!');
    Key := #0;
  end;
end;

procedure TfrmHW_EmployeeID.FormCreate(Sender: TObject);
begin
  StartID := 0;
  EndID := 0;
end;

procedure TfrmHW_EmployeeID.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if not(Key in ['0'..'9', #8]) then
  begin
    ShowMess('please input a number!');
    Key := #0;
  end;
end;

procedure TfrmHW_EmployeeID.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not(Key in ['0'..'9', #8]) then
  begin
    ShowMess('please input a number!');
    Key := #0;
  end;
end;

procedure TfrmHW_EmployeeID.Button2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmHW_EmployeeID.Button1Click(Sender: TObject);
begin
  if Trim(rzedt_EmployeeID.Text) = '' then
  begin
    ShowMess('please input a employee id(begin)!');
    Exit;
  end;
  try
    StartID := StrToInt(Trim(rzedt_EmployeeID.Text));
  except
    ShowMess('please input a valid employee id(begin)');
    Exit;
  end;
  if not rzcbx_Single.Checked then
  begin
    if Trim(rzedt_EndID.Text) = '' then
    begin
      ShowMess('please input a employee id(end)!');
      Exit;
    end;
    try
      EndID := StrToInt(Trim(rzedt_EndID.Text));
    except
      ShowMess('please input a valid employee id(end)!');
      Exit;
    end;
    if StartID > EndID then
    begin
      ShowMess('the begin should not be bigger than the end, please input again!');
      Exit;
    end;
  end else
    EndID := StartID;
  ModalResult := mrOk;
end;

procedure TfrmHW_EmployeeID.rzcbx_SingleClick(Sender: TObject);
begin
  Label2.Enabled := (not rzcbx_Single.Checked);
  rzedt_EndID.Enabled := (not rzcbx_Single.Checked);
end;

end.
