unit UntHW_SelectDateTime;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmHW_SelectDateTime = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Label3: TLabel;
    dtp_End: TDateTimePicker;
    Label4: TLabel;
    dtp_EndTime: TDateTimePicker;
    Panel3: TPanel;
    Label1: TLabel;
    dtp_Start: TDateTimePicker;
    Label2: TLabel;
    dtp_StartTime: TDateTimePicker;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
//    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    StartDate,
    EndDate,
    StartDateTime,
    EndDateTime: TDateTime;
  end;

var
  frmHW_SelectDateTime: TfrmHW_SelectDateTime;

implementation

uses
  UntPublic, DateUtils;

{$R *.dfm}

procedure TfrmHW_SelectDateTime.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close;
end;

procedure TfrmHW_SelectDateTime.Button1Click(Sender: TObject);
begin
  StartDate := DateOf(dtp_Start.DateTime);
  EndDate := DateOf(dtp_End.DateTime);
  StartDateTime := TimeOf(dtp_StartTime.DateTime);
  EndDateTime := TimeOf(dtp_EndTime.DateTime);
  if StartDate > EndDate then
  begin
    ShowMess('End date should not before begin date!');
    Exit;
  end;
  if (StartDate = EndDate) and (StartDateTime > EndDateTime) then
  begin
    ShowMess('End time should not before begin time!');
    Exit;
  end;
  StartDate := DateOf(dtp_Start.DateTime);
  EndDate := DateOf(dtp_End.DateTime);
  StartDateTime := TimeOf(dtp_StartTime.DateTime);
  EndDateTime := TimeOf(dtp_EndTime.DateTime);
  ModalResult := mrOk;
end;

procedure TfrmHW_SelectDateTime.Button2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;                   

end.
